% nitcthesisB5.cls
% LaTeX Style file for the National Institute of Technology Calicut
%   Compiled by M. P. Gilesh
%   Email : gileshmp@ieee.org
%   Approved by Dr. Muralikrishanan K, Dept of CSE, NIT Calicut
%               Dr. Subhasree, Dept of CSE, NIT Calicut
%		Dr. S. M. Sameer, Dept of ECE, NIT Calicut
%		Dr. S. D. Madhu Kumar, Dept of CSE, NIT Calicut


% Acknowledgemennts
% % % Cambridge University 
% % % IIT Bombay

\newcommand\docversion{2.0.0}
\newcommand\docdate{2019/06/06}
\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{Classes/nitcthesisB5}[\docdate\space NIT Calicut PhD thesis format by M. P. Gilesh (v\docversion)]
\typeout{http://nitc.ac.in/downloads/academic/forms/phd-thesis-template}

% *********************** Define a Print/Online Version ************************
\newif\if@print\@printfalse
\DeclareOption{print}{\@printtrue}

% ****************************** Define index **********************************
\newif\ifPHD@index\PHD@indexfalse
\DeclareOption{index}{\PHD@indextrue}

% % ****************************** Define glossary **********************************
% \newif\ifPHD@glossary\PHD@glossaryfalse
% \DeclareOption{glossary}{\PHD@glossarytrue}


% ******************************* Font Option **********************************
\newif\ifsetFont\setFontfalse                 % Font is not set

\newif\ifPHD@times\PHD@timesfalse             % Times with Math Support
\DeclareOption{times}{
  \ifsetFont
    \ClassWarning{nitcthesis}{Font selection conflict: A font package was
      aleady specified. Please check the document class options in case you 
      have defined two fonts.}
  \else
    \PHD@timestrue
    \setFonttrue
  \fi
}

\newif\ifPHD@fourier\PHD@fourierfalse         % Fourier with Math Support
\DeclareOption{fourier}{
  \ifsetFont
    \ClassWarning{nitcthesis}{Font selection conflict: A font package was
      aleady specified. Please check the document class options in case you 
      have defined two fonts.}
  \else
    \PHD@fouriertrue
    \setFonttrue
  \fi
}

\newif\ifPHD@serif\PHD@seriffalse         % Fourier with Math Support
\DeclareOption{serif}{
  \ifsetFont
    \ClassWarning{nitcthesis}{Font selection conflict: A font package was
      aleady specified. Please check the document class options in case you 
      have defined two fonts.}
  \else
    \PHD@seriftrue
    \setFonttrue
  \fi
}

\newif\ifsetCustomFont\setCustomFontfalse     % Custom Font with Math Support
\DeclareOption{customfont}{
  \ifsetFont
    \ClassWarning{nitcthesis}{Font selection conflict: A font package was
      aleady specified. Please check the document class options in case you 
      have defined two fonts.}
  \else
    \setCustomFonttrue
    \setFonttrue
  \fi
}


% ******************************* Bibliography *********************************
\newif\ifsetBib\setBibfalse                   % Custom Bibliography = true/false
\newif\ifsetBiBLaTeX\setBiBLaTeXfalse         % BiBLaTeX = True / False

\newif\ifPHD@biblatex\PHD@biblatexfalse       % BiBLaTeX
\DeclareOption{biblatex}{
  \ifsetBib
    \ClassWarning{nitcthesis}{Bibliography selection conflict: A
      bibliography style aleady specified. Please check the document class
      options in case you have defined two bibliography styles.}
  \else
    \PHD@biblatextrue
  \fi
}

\newif\ifPHD@authoryear\PHD@authoryearfalse   % Author-Year citation
\DeclareOption{authoryear}{
  \ifsetBib
    \ClassWarning{nitcthesis}{Bibliography selection conflict: A
      bibliography style aleady specified. Please check the document class
      options in case you have defined two bibliography styles.}
  \else
    \PHD@authoryeartrue
    \setBibtrue
  \fi
}

\newif\ifPHD@numbered\PHD@numberedfalse       % Numbered citiation
\DeclareOption{numbered}{
  \ifsetBib
    \ClassWarning{nitcthesis}{Bibliography selection conflict: A
      bibliography style aleady specified. Please check the document class
      options in case you have defined two bibliography styles.}
  \else
    \PHD@numberedtrue
    \setBibtrue
  \fi
}

\newif\ifuseCustomBib\useCustomBibfalse     % Custom Bibliography
\DeclareOption{custombib}{
  \ifsetBib
    \ClassWarning{nitcthesis}{Bibliography selection conflict: A
      bibliography style aleady specified. Please check the document class
      options in case you have defined two bibliography styles.}
  \else
    \ifPHD@biblatex
        \ClassWarning{nitcthesis}{Bibliography selection conflict: A
          bibliography style aleady specified. Please check the document class
          options in case you have defined two bibliography styles.}
    \else
      \useCustomBibtrue
      \setBibtrue
    \fi
  \fi
}

% ************************* Header / Footer Styling ****************************
\newif\ifPHD@textJustify\PHD@textJustifytrue % Set Justification true
\DeclareOption{flushleft}{\PHD@textJustifyfalse}


% ************************* Header / Footer Styling ****************************
\newif\ifPHD@pageStyleI\PHD@pageStyleIfalse % Set Page StyleI
\DeclareOption{PageStyleI}{\PHD@pageStyleItrue}

\newif\ifPHD@pageStyleII\PHD@pageStyleIIfalse % Set Page StyleII
\DeclareOption{PageStyleII}{\PHD@pageStyleIItrue}

\newif\ifPHD@pageStyleIII\PHD@pageStyleIIIfalse % Set Page StyleII
\DeclareOption{PageStyleIII}{\PHD@pageStyleIIItrue}

% ***************************** Custom Margins  ********************************
\newif\ifsetCustomMargin\setCustomMarginfalse % Set Custom Margin
\newif\ifsetMargin\setMarginfalse % Set Custom Margin
\DeclareOption{custommargin}{\setCustomMargintrue}


% **************************** Separate Abstract  ******************************
\newif \ifdefineAbstract\defineAbstractfalse %To enable Separate abstract

\newif\ifPHD@abstract\PHD@abstractfalse % Enable Separate Abstract
\DeclareOption{abstract}{
  \PHD@abstracttrue
  \ClassWarning{nitcthesis}{You have chosen an option that generates only
    the Title page and an abstract with PhD title and author name, if this was
    intentional, ignore this warning. Congratulations on submitting your thesis!
    If not, please remove the option `abstract' from the document class and
    recompile. Good luck with your writing!}
  \PassOptionsToClass{oneside}{book}
}

% ****************** Chapter Mode - To print only selected chapters ************
\newif \ifdefineChapter\defineChapterfalse %To enable Separate abstract

\newif\ifPHD@chapter\PHD@chapterfalse % Only selected chapters
\DeclareOption{chapter}{
  \PHD@chaptertrue
  \ClassWarning{nitcthesis}{You have chosen an option that generates only 
    selected chapters with references, if this was intentional, ignore this
    warning. If not, please remove the option `chapter' from the document class
    and recompile. Good luck with your writing!}
}

% *************************** Pre-defined Options ******************************
% Font Size
\DeclareOption{11pt}{
  \ClassWarning{nitcthesis}{Follow the NIT Calicut PhD thesis guidelines.}
  \PassOptionsToClass{11pt}{book}%
}

% \DeclareOption{11pt}{\PassOptionsToClass{11pt}{book}}%
\DeclareOption{12pt}{\PassOptionsToClass{12pt}{book}}%

% Page Size
\newcommand\PHD@papersize{b5paper} % Set Default as b5paper

\DeclareOption{b5paper}{\renewcommand\PHD@papersize{b5paper}}
% \DeclareOption{a5paper}{\renewcommand\PHD@papersize{a5paper}}
\DeclareOption{letterpaper}{
  \ClassWarning{nitcthesis}{NIT Calicut PhD thesis guidelines recommends using B5 paper}
  \renewcommand\PHD@papersize{letterpaper}
}

\PassOptionsToClass{\PHD@papersize}{book}%

% Column layout
\newif\if@oneside\@onesidefalse
\DeclareOption{oneside}{\PassOptionsToClass{\CurrentOption}{book}\@onesidetrue}%
\DeclareOption{twoside}{\PassOptionsToClass{\CurrentOption}{book}}%


% ****************************** Draft Option **********************************
\newif\ifsetDraft\setDraftfalse
\newif\ifsetDraftClassic\setDraftClassicfalse
% Draft Mode
\DeclareOption{draftclassic}{\PassOptionsToClass{draft}{book}
  \setDraftClassictrue
  \ClassWarning{nitcthesis}{Draft is ON. Don't forget to turn it
    off in your final version. This is the classic version of draft.
    Use `draft' for enhanced mode, which adds watermark with timestamp, 
    line numbering, and version number.}}%

\DeclareOption{draft}{\PassOptionsToClass{\CurrentOption}{book}
  \setDrafttrue 
  \ClassWarning{nitcthesis}{Draft is ON. Don't forget to turn it
    off in your final version. This enhanced `draft' mode adds watermark 
    with timestamp, line numbering, and version number. Use `draftclassic'
    if you prefer the \cite{} lassic draft mode. To tweak options see
    `preamble.tex'}}%
    
% Line Numbers
\newif\ifPHD@lineno\PHD@linenotrue
\DeclareOption{lineno}{\PHD@linenotrue}
\DeclareOption{nolineno}{\PHD@linenofalse}


% Generates Warning for unknown options
\DeclareOption*{
  \ClassWarning{nitcthesisB5}{Unknown or non-standard option
'\CurrentOption'. I'll see if I can load it from the book class. If you get a
warning unused global option(s): `\CurrentOption` then the option is not
supported!}
\PassOptionsToClass{\CurrentOption}{book}
}

% Process options and load class
\ProcessOptions\relax%
\LoadClass{book}%

% ******************************************************************************
% ******************************** Packages ************************************
% ******************************************************************************
% ************************** Layout and Formatting *****************************

\RequirePackage[T1]{fontenc}
\RequirePackage{lmodern}
\RequirePackage{lscape}   % Supports Landscape Layout
\RequirePackage{setspace} % Define line spacing in paragraph
\RequirePackage{calc}     % calculate vertical spacing

% ************************* Conditional Statements *****************************
\RequirePackage{ifthen}   % Conditional statements
\RequirePackage{ifpdf}    % Check for pdfLaTeX
\RequirePackage{ifxetex}  % XeLaTeX

% *********************** Table of Contents & Appendices ***********************
% add Bibliography, List of figures and tables to contents
\RequirePackage[nottoc]{tocbibind}
% Add appendices
\RequirePackage[title,titletoc]{appendix}

\renewcommand{\contentsname}{Contents}
\renewcommand{\listfigurename}{List of Figures}
\renewcommand{\listtablename}{List of Tables}

% Hides Contents appearing from TOC, but adds it to bookmarks
\let\temptableofcontents\tableofcontents
\renewcommand{\tableofcontents}{
  \cleardoublepage
  \pdfbookmark[0]{\contentsname}{Contents}
%   \pagestyle{PageStyleIII}
  \temptableofcontents
  
}

% *************************** Graphics and Figures *****************************
\RequirePackage[usenames, dvipsnames]{color}
\ifpdf
  % Convert eps figures to pdf
  \RequirePackage{epstopdf}
  \RequirePackage[pdftex]{graphicx}
  \DeclareGraphicsExtensions{.png, .jpg, .pdf}
  \pdfcompresslevel=9
  \graphicspath{{Figs/Raster/}{Figs/}}
\else
  \RequirePackage{graphicx}
  \DeclareGraphicsExtensions{.eps, .ps}
  \graphicspath{{Figs/Vector/}{Figs/}}
\fi

% ******************************* Time Stamp ***********************************
% Compute the timestamp based on an idea of
% Tim Piessens \texttt{<Tim.Piessens@esat.kuleuven.ac.be>}.

\RequirePackage{datetime}

\newcount\PHD@hour \newcount\PHD@minute
\PHD@hour=\time
\divide \PHD@hour by 60
\PHD@minute=\time
\count@=\PHD@hour
\multiply \count@ by -60
\advance \PHD@minute by \count@
\newcommand{\PHD@daytime}{%
  \today\space--\space%
  \ifnum\PHD@hour=0 00\else\ifnum\PHD@hour<10 0\fi%
  \number\PHD@hour\fi:\ifnum\PHD@minute<10 0\fi\number\PHD@minute
}

% ******************************* Draft Mode ***********************************
% Initializing Draft Text
\newcommand\SetDraftText[1]{}
% Initializing Draft Version
\newcommand\SetDraftVersion[1]{}
% Initializing Draft Content
\newcommand\SetDraftWMPosition[1]{}
% Initializing Draft Gray Scale
\newcommand\SetDraftGrayScale[1]{}

% Classic Draft Mode
\ifsetDraftClassic
% Disable figures in `draft'\
\setkeys{Gin}{draft=true}
\fi

% If Draft Mode is active
\ifsetDraft
% Disable figures in `draft'\
\setkeys{Gin}{draft=false}

% Line numbering (can be switched off)
\ifPHD@lineno
\RequirePackage[switch,pagewise,mathlines]{lineno}
\renewcommand{\frontmatter}{%
  \cleardoublepage
  \@mainmatterfalse
  \pagenumbering{roman}
  \nolinenumbers
}


\renewcommand{\mainmatter}{%
  \cleardoublepage
  \@mainmattertrue
  \pagenumbering{arabic}
  \linenumbers
}
\renewcommand{\backmatter}{%
  \if@openright
    \cleardoublepage
  \else
    \clearpage
  \fi
  \@mainmatterfalse
  \linenumbers
}

% Fix display lineno issue in mathmode
\newcommand*\patchAmsMathEnvironmentForLineno[1]{%
  \expandafter\let\csname old#1\expandafter\endcsname\csname #1\endcsname
  \expandafter\let\csname oldend#1\expandafter\endcsname\csname end#1\endcsname
  \renewenvironment{#1}%
     {\linenomath\csname old#1\endcsname}%
     {\csname oldend#1\endcsname\endlinenomath}%
}% 

\newcommand*\patchBothAmsMathEnvironmentsForLineno[1]{%
  \patchAmsMathEnvironmentForLineno{#1}%
  \patchAmsMathEnvironmentForLineno{#1*}%
}%

\AtBeginDocument{%
  \patchBothAmsMathEnvironmentsForLineno{equation}%
  \patchBothAmsMathEnvironmentsForLineno{align}%
  \patchBothAmsMathEnvironmentsForLineno{flalign}%
  \patchBothAmsMathEnvironmentsForLineno{alignat}%
  \patchBothAmsMathEnvironmentsForLineno{gather}%
  \patchBothAmsMathEnvironmentsForLineno{multline}%
}

\fi % End \ifPDH@lineno


% Creates a Watermark Draft at the specified location.
% The settings can be tweaked in the preamble

% Draft text
\newcommand\drafttext{Draft \@doctype}
\renewcommand\SetDraftText[1]{%
  \renewcommand\drafttext{#1}
}

% Draft Version
\newcommand\draftVersion{v1.0}
\renewcommand\SetDraftVersion[1]{%
  \renewcommand\draftVersion{#1}
}

% Draft Gray Scale
\newcommand\draftGrayScale{0.55}
\renewcommand\SetDraftGrayScale[1]{%
  \renewcommand\draftGrayScale{#1}
}

% Draft Content
\newcommand\DraftContent{%
  \hspace*{\fill}
  \Large
  \textcolor[gray]{\draftGrayScale}{%
    {\drafttext}\space-\space{v\draftVersion}\hspace{\stretch{1}}{\PHD@daytime}
    \hspace*{\fill}
  }
}


% Adding watermark in draft mode with time stamp
\RequirePackage{everypage}
\RequirePackage[absolute]{textpos}
% Default values for draft watermark
\newcommand\draftposition{top}
\newcommand\draftnodeanchor{1in+\voffset-\topmargin}
\AddEverypageHook{%
  \begin{textblock*}{\paperwidth}[0.,2.5](0\paperwidth,\draftnodeanchor)
    \DraftContent
  \end{textblock*}
}

% Conditional evaluation to position the draft water mark  (top / bottom)
\renewcommand\SetDraftWMPosition[1]{%
  \renewcommand\draftposition{#1}
  \ifthenelse{\equal{\draftposition}{bottom}}
    {\renewcommand\draftnodeanchor{\paperheight-\voffset}} %Bottom
    {\ifthenelse{\equal{\draftposition}{top}}
      {\renewcommand\draftnodeanchor{1in+\voffset-\topmargin}} %Top
      {\ClassWarning{nitcthesis}{Unrecognised draft position
          using default value of top}
        \renewcommand\draftnodeanchor{1in+\voffset-\topmargin}}} %Top
    
    \AddEverypageHook{%
    \begin{textblock*}{\paperwidth}[0.,2.5](0\paperwidth,\draftnodeanchor)
      \DraftContent
    \end{textblock*}
  }
}

% If NOT a Draft
\else 

\renewcommand\SetDraftText[1]{\ClassWarning{nitcthesis}{Draft is
    inactive, to use SetDraftText include `draft' in the document 
    class options.}}
% Draft Version
\renewcommand\SetDraftVersion[1]{\ClassWarning{nitcthesis}{Draft is
    inactive, to use SetDraftVersion include `draft' in the document
    class options.}}
% Draft Content
\renewcommand\SetDraftWMPosition[1]{\ClassWarning{nitcthesis}{Draft
    is inactive, to use SetDraftWMPosition include `draft' in the document
    class options.}}

\renewcommand\SetDraftGrayScale[1]{\ClassWarning{nitcthesis}{Draft is
    inactive, to use SetDraftWMPosition include `draft' in the document
    class options.}}
\fi


% ******************************* Bibliography *********************************
\ifPHD@authoryear
  \ifPHD@biblatex
    \RequirePackage[backend=biber, style=authoryear, citestyle=alphabetic, 
      sorting=nty, natbib=true]{biblatex}
    \setBiBLaTeXtrue
  \else
    \RequirePackage[round, sort, numbers, authoryear]{natbib} %author year
  \fi
\else
  \ifPHD@numbered
    \ifPHD@biblatex
      \RequirePackage[backend=biber, style=numeric-comp, 
        citestyle=numeric, sorting=none, natbib=true]{biblatex}
      \setBiBLaTeXtrue
    \else
      \RequirePackage[numbers,compress]{natbib} % numbered citation
    \fi
  \else
    \ifuseCustomBib
       \AtBeginDocument{
          \@ifpackageloaded{natbib}{}{
            \@ifpackageloaded{biblatex}{}{
              \ClassWarning{nitcthesis}{%
                You chose custom bibliography, but no corresponding package 
                (biblatex/natbib) has been loaded. Please load the
                appropriate bibliography package in the preamble.}
            }
          }
        }
    \else                                            % set default to numbered
      \ifPHD@biblatex
        \RequirePackage[backend=biber, style=numeric-comp,
          citestyle=numeric, sorting=none, natbib=true]{biblatex}
        \setBiBLaTeXfalse
      \else
        \RequirePackage[numbers,compress]{natbib} 
      \fi % default
      \setBibfalse
    \fi % custombib
  \fi % numbered
\fi % author year

\ifsetBib
\else
\ClassWarning{nitcthesis}{No bibliography style was specified.
  Default numbered style is used. If you would like to use a 
  different style, use `authoryear' or `numbered' in the options in
  documentclass or use `custombib` and define the natbib package or
  biblatex package with required style in the Preamble.tex file}
\fi


% ********************************** Fonts **********************************
\RequirePackage{textcomp}
% Font Selection
\ifPHD@times
  \ifxetex
  \else
    \RequirePackage{mathptmx}  % times roman, including math (where possible)
  \fi
  \setFonttrue
  \message{nitcthesis: Using Times Roman font}
\else
  \ifPHD@fourier
    \RequirePackage{sty/fourier} % Fourier
    \setFonttrue
    \message{nitcthesis: Using Fourier font}
  \else
    \ifPHD@serif
      \RequirePackage{sansmath} % Fourier
      \setFonttrue
      \message{nitcthesis: Using Serif font}
    \else
      \ifsetCustomFont
        \setFonttrue
        \message{nitcthesis: Using custom font}
      \else
        \setFontfalse
        \message{nitcthesis: No font is set}
      \fi %Custom font
    \fi % Serif font
  \fi % Fourier font
\fi % Times font

% If Font is not set throw a warning.
\ifsetFont
\else
  \ClassWarning{nitcthesis}{Using default font Latin Modern. If you
    would like to use other pre-defined fonts use `times' (The NIT Calicut
    PhD thesis guidelines recommend using Times font)  or `fourier'
    or load a custom font in the preamble.tex file by specifying `customfont' 
    in the class options}
  \RequirePackage{lmodern}
\fi


\ifxetex
  % XeLaTeX
  \usepackage{amsmath}
  \usepackage{fontspec}
  \usepackage[]{unicode-math}
  \setmainfont[
    Extension = .otf,
    UprightFont = *-regular,
    BoldFont = *-bold,
    ItalicFont = *-italic,
    BoldItalicFont = *-bolditalic,
  ]{xits}
  
  \setmathfont[ 
    Extension = .otf,
    BoldFont = *bold,
  ]{xits-math}
  
\else
  % default: pdfLaTeX
  \RequirePackage[utf8]{inputenc}
  \RequirePackage[T1]{fontenc}
  
  % If building with PDFLaTeX, use microtype spacing adjustments
  \RequirePackage[final]{microtype}
  
  \input{glyphtounicode}
  \pdfglyphtounicode{f_f}{FB00}
  \pdfglyphtounicode{f_i}{FB01}
  \pdfglyphtounicode{f_l}{FB02}
  \pdfglyphtounicode{f_f_i}{FB03}
  \pdfglyphtounicode{f_f_l}{FB04}
  \pdfgentounicode=1

  \RequirePackage{amsfonts}
  \RequirePackage{amsmath}
  \RequirePackage{amssymb}
\fi

% Don't break enumeration (etc.) across pages in an ugly manner
\clubpenalty=10000
\widowpenalty=10000

%******************************* Print / Online ********************************
% Defines a print / online version to define page-layout and hyperrefering

% Moved below other usepackage definitions to fix PDFLaTeX footnote warning
% Based on the suggestion by John Plaice

\definecolor{brown}{rgb}{0.65, 0.16, 0.16}
\RequirePackage[unicode=true]{hyperref}

\if@print
  % For Print version
  \hypersetup{
    final=true,
    plainpages=false,
    pdfstartview=FitV,
    pdftoolbar=true,
    pdfmenubar=true,
    bookmarksopen=true,
    bookmarksnumbered=true,
    breaklinks=true,
    linktoc=all,
%     linktocpage,
    colorlinks=true,
    linkcolor=black,
    urlcolor=black,
    citecolor=black,
    anchorcolor=black
  }
  \ifsetCustomMargin
  % Margin to be define in preamble using geometry package
  \else
    \RequirePackage[paper=\PHD@papersize,hmarginratio=1:1,
      vmarginratio=1:1,scale=0.75,bindingoffset=.5cm]{geometry}
  \fi

  \if@twoside
    \hypersetup{pdfpagelayout=TwoPageRight}
  \else
    \hypersetup{pdfpagelayout=OneColumn}
  \fi

\else
  % For PDF Online version
  \hypersetup{
    final=true,
    plainpages=false,
    pdfstartview=FitV,
    pdftoolbar=true,
    pdfmenubar=true,
    bookmarksopen=true,
    bookmarksnumbered=true,
    breaklinks=true,
    linktoc=all,
%     linktocpage,
    colorlinks=true,
    linkcolor=brown,
    urlcolor=brown,
    citecolor=blue,
    anchorcolor=green
  }

  \ifsetCustomMargin
    % Margin to be define in preamble using geometry package
    \else
      % No Margin staggering on Odd and Even side
      \RequirePackage[paper=\PHD@papersize,hmarginratio=1:1,
        vmarginratio=1:1,scale=0.75]{geometry} % dvips
    \fi
    \hypersetup{pdfpagelayout=OneColumn}
\fi

% ************************ URL Package and Definition **************************
\RequirePackage{url}
% Redefining urlstyle to use smaller fontsize in References with URLs
\newcommand{\url@leostyle}{%
 \@ifundefined{selectfont}{\renewcommand{\UrlFont}{\sffamily}}
 {\renewcommand{\UrlFont}{\normalsize}}}
\urlstyle{leo}

% option to split urls over multiple lines for latex >> DVIPS >> PDF option
\ifpdf
  % PDFLaTeX does it automatically.
\else
  % dvips
  \RequirePackage{breakurl} % to split the url over multiple lines
\fi
  
% ******************************************************************************
% **************************** Pre-defined Settings ****************************
% ******************************************************************************

% *************************** Setting PDF Meta-Data ****************************
\ifpdf
\AtBeginDocument{
  \hypersetup{
    pdftitle = {\@title},
    pdfauthor = {\@author},
    pdfsubject={\@subject},
%     pdfkeywords={\@keywords}
  }
}
\fi

% ******************************** Line Spacing ********************************
% Set spacing as 1.5 line spacing for the PhD Thesis
% In practice, fortunately, nobody knows really what “one-and-a-half spaced
% type” means exactly (in terms of millimetres baseline distance). The following
% LaTeX setting has routinely been considered perfectly acceptable:

\renewcommand\baselinestretch{1.2}

% ******************************** Justification *******************************
% Left aligned as per University identity guidelines
\ifPHD@textJustify
\message{nitcthesis: NIT Calicut identity guidelines recommend using 
left aligned text. Please use `flushleft' in the documentclass option, if you
wish to left align your text}
\else
\AtBeginDocument{
\raggedright
}
\fi


% ************************** TOC and Hide Sections *****************************
\newcommand{\nocontentsline}[3]{}
\newcommand{\tochide}[2]{
	\bgroup\let
	\addcontentsline=\nocontentsline#1{#2}
	\egroup}
% Removes pagenumber appearing from TOC
% \addtocontents{toc}{\protect\thispagestyle{empty}}


% ***************************** Header Formatting ******************************
% Custom Header with Chapter Number, Page Number and Section Numbering

\RequirePackage{fancyhdr} % Define custom header

% Style 1: Sets Page Number at the Top and Chapter/Section Name on LE/RO
\fancypagestyle{PageStyleI}{
  \renewcommand{\chaptermark}[1]{\markboth{##1}{}}
  \renewcommand{\sectionmark}[1]{\markright{\thesection\ ##1\ }}
  \fancyhf{}
  \fancyhead[RO]{\nouppercase \rightmark\hspace{0.25em} | 
    \hspace{0.25em} \bfseries{\thepage}}
  \fancyhead[LE]{ {\bfseries\thepage} \hspace{0.25em} | 
    \hspace{0.25em} \nouppercase \leftmark}
}

% Style 2: Sets Page Number at the Bottom with Chapter/Section Name on LO/RE
\fancypagestyle{PageStyleII}{
  \renewcommand{\chaptermark}[1]{\markboth{##1}{}}
  \renewcommand{\sectionmark}[1]{\markright{\thesection\ ##1}}
  \fancyhf{}
  \fancyhead[RO]{\bfseries\nouppercase \rightmark}
  \fancyhead[LE]{\bfseries \nouppercase \leftmark}
  \fancyfoot[C]{\thepage}
}

\fancypagestyle{PageStyleIII}{
  \renewcommand{\chaptermark}[1]{\markboth{##1}{}}
  \renewcommand{\sectionmark}[1]{\markright{\thesection\ ##1}}
  \renewcommand{\headrulewidth}{0pt}
  \fancyhf{}
  \fancyhead[RO]{\bfseries\nouppercase \rightmark}
  \fancyhead[LE]{\bfseries \nouppercase \leftmark}
  \fancyfoot[C]{\thepage}
}

% Set Fancy Header Command is defined to Load FancyHdr after Geometry is defined
\newcommand{\setFancyHdr}{

\pagestyle{fancy}

\ifPHD@pageStyleI
  % Style 1: Sets Page Number at the Top and Chapter/Section Name on LE/RO
  \pagestyle{PageStyleI}

\else
  \ifPHD@pageStyleII

  % Style 2: Sets Page Number at the Bottom with Chapter/Section Name on LO/RE
  \pagestyle{PageStyleII}

\else
  \ifPHD@pageStyleIII

  % Style 2: Sets Page Number at the Bottom with Chapter/Section Name on LO/RE
   \pagestyle{PageStyleIII}

\else
  
  % Default Style: Sets Page Number at the Top (LE/RO) with Chapter/Section Name
  % on LO/RE and an empty footer
    \renewcommand{\chaptermark}[1]{\markboth {##1}{}}
    \renewcommand{\sectionmark}[1]{\markright{\thesection\ ##1}}
    \fancyhf{}
    \fancyhead[LO]{\nouppercase \leftmark}
    \fancyhead[LE,RO]{\thepage}
    \fancyhead[RE]{\nouppercase \leftmark}
   \fi
  \fi
\fi
}

\setlength{\headheight}{14.5pt}
%\renewcommand{\headrulewidth}{0.5pt}
%\renewcommand{\footrulewidth}{0pt}
\fancypagestyle{plain}{
  \fancyhead{}
  \renewcommand{\headrulewidth}{0pt}
}

% If Margin has been set (default margin print/online version)
\ifsetCustomMargin
\AtBeginDocument{
\@ifpackageloaded{geometry}{}{\ClassWarning{nitcthesis}{%
  Custom margin is chosen, but geometry package is not loaded. Please load the
  `geometry' package in the preamble.}}}
\else
\setFancyHdr % Apply fancy header settings otherwise apply it in preamble
\fi

% **************** Clear Header Style on the Last Empty Odd pages **************
\renewcommand{\cleardoublepage}{\clearpage\if@twoside \ifodd\c@page\else%
	\hbox{}%
	\thispagestyle{empty}  % Empty header styles
	\newpage%
	\if@twocolumn\hbox{}\newpage\fi\fi\fi}


% ******************************************************************************
% **************************** Macro Definitions *******************************
% ******************************************************************************
% These macros are used to declare arguments needed for the
% construction of the title page and other preamble.

% Type of documents
\newcommand{\@doctype}{}
\newcommand{\doctype}[1]{\renewcommand{\@doctype}{#1}}

% Roll No
\newcommand{\@rollnum}{}
\newcommand{\rollnum}[1]{\renewcommand{\@rollnum}{#1}}

% Subtitle (optional)
\newcommand{\@subtitle}{}
\newcommand{\subtitle}[1]{\renewcommand{\@subtitle}{#1}}

% The year and term the degree will be officially conferred
\newcommand{\@degreedate}{\monthname[\the\month]\space\the\year}
\newcommand{\degreedate}[1]{\renewcommand{\@degreedate}{#1}}

% The full (unabbreviated) name of the degree
\newcommand{\@degreetitle}{}
\newcommand{\degreetitle}[1]{\renewcommand{\@degreetitle}{#1}}

% The name of your department(eg. Engineering, Maths, Physics)
\newcommand{\@dept}{}
\newcommand{\dept}[1]{\renewcommand{\@dept}{#1}}

% The name of your college (eg. King's)
\newcommand{\@college}{}
\newcommand{\college}[1]{\renewcommand{\@college}{#1}}


% The name of your University
\newcommand{\@university}{}
\newcommand{\university}[1]{\renewcommand{\@university}{#1}}

\newcommand{\@univaddress}{}
\newcommand{\univaddress}[1]{\renewcommand{\@univaddress}{#1}}

\newcommand{\@place}{}
\newcommand{\place}[1]{\renewcommand{\@place}{#1}}

% Defining the crest
\newcommand{\@crest}{}
\newcommand{\crest}[1]{\renewcommand{\@crest}{#1}}

% Defining the crest blue
\newcommand{\@bluecrest}{}
\newcommand{\bluecrest}[1]{\renewcommand{\@bluecrest}{#1}}

\newif\ifAUTH@male\AUTH@malefalse
\newcommand{\@authgender}{}%
\newcommand{\authgender}[1]{\ifthenelse{\equal{#1}{M}}\AUTH@maletrue}

% Supervisor
\newif\ifPHD@guide\PHD@guidefalse
\newcommand{\@guide}{}
\newcommand{\guide}[1]{\renewcommand{\@guide}{#1}\PHD@guidetrue}

\newif\ifPHD@guidepost\PHD@guidepostfalse
\newcommand{\@guidepost}{}
\newcommand{\guidepost}[1]{\renewcommand{\@guidepost}{#1}\PHD@guideposttrue}

\newif\ifPHD@guidedept\PHD@guidedeptfalse
\newcommand{\@guidedept}{}
\newcommand{\guidedept}[1]{\renewcommand{\@guidedept}{#1}\PHD@guidedepttrue}

\newif\ifPHD@guideuniv\PHD@guideunivfalse
\newcommand{\@guideuniv}{}
\newcommand{\guideuniv}[1]{\renewcommand{\@guideuniv}{#1}\PHD@guideunivtrue}

% % guide width to align
% \newcommand{\@guidelinewidth}{\linewidth}
% \newcommand{\guidelinewidth}[1]{\renewcommand{\@guidelinewidth}{#1}}

\newif\ifPHD@coguide\PHD@coguidefalse
\newcommand{\@coguide}{}
\newcommand{\coguide}[1]{\renewcommand{\@coguide}{#1}\PHD@coguidetrue}


\newif\ifPHD@coguidepost\PHD@coguidepostfalse
\newcommand{\@coguidepost}{}
\newcommand{\coguidepost}[1]{\renewcommand{\@coguidepost}{#1}\PHD@coguideposttrue}

\newif\ifPHD@coguidedept\PHD@coguidedeptfalse
\newcommand{\@coguidedept}{}
\newcommand{\coguidedept}[1]{\renewcommand{\@coguidedept}{#1}\PHD@coguidedepttrue}


\newif\ifPHD@coguideuniv\PHD@coguideunivfalse
\newcommand{\@coguideuniv}{}
\newcommand{\coguideuniv}[1]{\renewcommand{\@coguideuniv}{#1}\PHD@coguideunivtrue}

\newif\ifPHD@guidemore\PHD@guidemorefalse
\newcommand{\@guidemore}{}
\newcommand{\guidemore}[1]{\renewcommand{\@guidemore}{#1}\PHD@coguidetrue}
% 
% % guide width to align
% \newcommand{\@coguidelinewidth}{\numchars{\@coguide}}
% \newcommand{\coguidelinewidth}[1]{\renewcommand{\@coguidelinewidth}{#1}}

% Submission Text
\newcommand{\submissiontext}{Submitted in  Partial Fulfillment of the  \\ Requirements for the Degree of }
\newcommand{\supervisetext}{under the supervision of }

% keywords (These keywords will appear in the PDF meta-information
% called `pdfkeywords`.)
% \newcommand{\@keywords}{}
% \newcommand{\keywords}[1]{\renewcommand{\@keywords}{#1}}

% subjectline (This subject will appear in the PDF meta-information
% called `pdfsubject`.)
\newcommand{\@subject}{}
\newcommand{\subject}[1]{\renewcommand{\@subject}{#1}}

% \usepackage{sectsty}
% \chapternumberfont{\huge} 
% \chaptertitlefont{\huge}

% These macros define an environment for front matter that is always
% single column even in a double-column document.
\newenvironment{alwayssingle}{%
       \@restonecolfalse\if@twocolumn\@restonecoltrue\onecolumn
       \else\newpage\fi}
       {\if@restonecol\twocolumn\else\newpage\fi}

% Set single column even under two column layout
\newcommand{\setsinglecolumn}{
\if@twocolumn
   \onecolumn
\else
\fi
}

\def\keywords{\vspace{1em}
\noindent{\textit{\textbf{Keywords}} :- \,\relax%
}}
\def\endkeywords{\par}

\RequirePackage{wrapfig}

\RequirePackage{caption}
\captionsetup[figure]{labelsep=space}
\captionsetup[table]{labelsep=space}

% ******************************************************************************
% *************************** Front Matter Layout ******************************
% ******************************************************************************

% ******************************** Title Page **********************************
\renewcommand{\maketitle}{

% To compute the free vertical space in Title page
\computeTitlePageSpacing

\thispagestyle{empty}
% \setcounter{page}{0}

\begin{singlespace}
\begin{center}

% % University Crest Long if college crest is defined
% \ifPHD@collegeshield%
% 	{\usebox{\PHD@crest}}
% 	\vspace{.15\PHD@titlepagespacing}
% \fi

% Title
{\usebox{\PHD@Title}} % subtitle is defined
\vspace{.13\PHD@titlepagespacing}

% Submission Text
{\usebox{\PHD@submission}}
\vspace{.1\PHD@titlepagespacing}

% Author
{\usebox{\PHD@author}}
\vspace*{1em}

% Supervise
{\usebox{\PHD@supervise}}
\vspace*{1em}

% guide
\ifPHD@guide%
{\usebox{\PHD@guide}}
% \vspace*{0.1em}
\fi

\ifPHD@coguide%
\vspace*{-0.5em}
{\usebox{\PHD@coguide}}
% \vspace*{0.5em}
\fi

\ifPHD@guidemore%
\vspace*{-0.5em}
{\usebox{\PHD@guidemore}}
% \vspace*{0.5em}
\fi

% \ifPHD@crest
{\usebox{\PHD@crest}}
\vspace{.05\PHD@titlepagespacing}
% \fi


% Department and University
{\usebox{\PHD@dept}}
\vspace{.1\PHD@titlepagespacing}


% College and degree date
\vfill
{\usebox{\PHD@collegedate}}
    
\end{center}

\end{singlespace}
}


\newcommand{\copyrightpage}
{
\cleardoublepage
\setsinglecolumn
\vspace*{0.3\textheight}
\thispagestyle{PageStyleIII}
\begin{center}
 \ifthenelse{\equal{\PHD@papersize}{b5paper}}{\large}{}
%     \ifthenelse{\equal{\PHD@papersize}{a5paper}}{\normalsize}{} 
       \textbf{\copyright~\@author,\space(\the\year)} \\ 
              
\end{center}
       NIT Calicut has the sole ownership of Patents and Software Copyrights resulting out of this Thesis work. NIT Calicut has the royalty-free permission to reproduce and distribute copies of this Thesis for teaching and research as well as for dissemination of teaching and research in other academic institutions.

% {\centering }
%\pagenumbering{roman} % Already in frotmater env!
}

% ********************************* Dedication *********************************
% The dedication environment makes sure the dedication gets its
% own page, centered

\newenvironment{dedication}
{
\cleardoublepage
\setsinglecolumn
\vspace*{0.2\textheight}
\thispagestyle{PageStyleIII}
\centering\ifthenelse{\equal{\PHD@papersize}{b5paper}}{\large}{}
%     \ifthenelse{\equal{\PHD@papersize}{a5paper}}{\normalsize}{} 
    \itshape
}

% ******************************* Declaration **********************************
% The declaration environment puts a large, bold, centered
% "Declaration" label at the top of the page.

\newcommand{\declarationpage}
{
\cleardoublepage
\setsinglecolumn
\chapter*{\centering \LARGE Declaration}
\thispagestyle{PageStyleIII}
% \begin{center}
 \ifthenelse{\equal{\PHD@papersize}{b5paper}}{\large}{}
%     \ifthenelse{\equal{\PHD@papersize}{a5paper}}{\normalsize}{}
      I hereby declare that except where specific reference is made to the work of others, the contents of this thesis are original and have not been  submitted in whole or in part for consideration for any other degree or qualification in this, or any other university. This thesis is my own work and contains nothing which is the outcome of work done in collaboration with others, except as specified in the text and Acknowledgements.
%  \end{center}

\vspace{60pt}
\hspace{0.4\textwidth} Signature \hspace{.2cm} : \par
\hspace{0.4\textwidth} Name \hspace{.9cm}: \@author{}  \par
\hspace{0.4\textwidth} Roll No \hspace{.55cm}: \@rollnum \\
\@place\\
\@date
\vfill
}



% ******************************* Certificate**********************************
% The certificate environment puts a large, bold, centered
% "Certificate" label at the top of the page.

\newcommand{\certificatepage}{
\cleardoublepage
\setsinglecolumn
\thispagestyle{PageStyleIII}
\begin{center}
% \newsavebox{\PHD@bluecrest}
\hspace{2.5cm}\@bluecrest
% \includegraphics[width=0.3\textwidth]{nitclogoblue.jpg}
\newline
\vspace*{.04\textheight}
{\LARGE \textbf{Certificate}}
\end{center}

\ifthenelse{\equal{\PHD@papersize}{b5paper}}{\normalsize}{}
% \ifthenelse{\equal{\PHD@papersize}{a5paper}}{\normalsize}{}
\noindent This is to certify that the thesis entitled \textbf{\@title} submitted by \textbf{\@author} to National Institute of Technology Calicut for the award of the degree of \@degreetitle \, is a bonafide record of the research work carried out by \ifAUTH@male him \else her \fi under \ifPHD@coguide our \else my \fi  supervision and guidance. The content of the thesis, in full or parts have not been submitted to any other institute or university for the award of any degree or diploma. 

\vspace*{.05\textheight}

\ifPHD@coguide
\noindent
  \begin{tabular}{@{}p{0.5\textwidth}p{0.5\textwidth}}\\
  \@guide & \@coguide \\
  \@guidepost &  \@coguidepost \\
  \@guidedept & \@coguidedept\\
  \@guideuniv & \@coguideuniv\\
  \end{tabular}

\else
  \noindent\hspace*{.5\textwidth} \@guide\\
  \hspace*{.5\textwidth} \@guidepost \\
  \hspace*{.5\textwidth} \@guidedept\\
  \hspace*{.5\textwidth} \@guideuniv\\
\fi

% \newline
\vspace*{.07\textheight}

\noindent\textit{Place :} NIT Calicut \hfill \textit{Signature of the Head of the department} \\ 
\textit{Date :~\_\_\_ /\_\_\_ /\_\_\_\_\_\_}
\vspace{.07\textheight}
\begin{center}
\textit{(Office Seal)}
\end{center}
}


% ******************************* Final Evaluation**********************************
% The command puts a large, bold, centered
% "Final Evauation" label at the top of the page.

\newcommand{\evaluationpage}{
\cleardoublepage
\setsinglecolumn
% \newgeometry{top=0.3cm}
\chapter*{\centering \LARGE Thesis Evaluation}
% \begin{center}
\thispagestyle{PageStyleIII}
% \end{center}
\begin{center}
This is to certify that \ifAUTH@male \textbf{Mr.} \else \textbf{Ms.} \fi \textbf{\@author} (Roll~No:~\@rollnum) has successfully defended the \@doctype ~entitled \textbf{\@title} 
on \_\_\_~/~\_\_\_~/~\_\_\_\_\_\_ \\[5mm]

The committee recommends the candidate for the award of the degree of \\ \textbf{\@degreetitle}.
\end{center}
% \newline
\vspace{.1\textheight}
\begin{tabular}{@{}p{.45\textwidth}p{.1\textwidth}p{.45\textwidth}}
 & & \\
 & &\\
\hrule width0.4\textwidth & & \hrule width0.4\textwidth \\
Signature of External Examiner &  & Signature of Internal Examiner \\
 & & \\
% Date:~\_\_/\_\_/\_\_\_\_ & & Date:~\_\_/\_\_/\_\_\_\_ \\
\end{tabular}
}


% ****************************** Acknowledgements ********************************
% The acknowledgements environment puts a large, bold, centered
% "Acknowledgements" label at the top of the page.

\newenvironment{acknowledgements}{
\cleardoublepage
\setsinglecolumn
\newgeometry{top=0.3cm}
\chapter*{\centering \LARGE Acknowledgements}
\thispagestyle{PageStyleIII}
}

\renewcommand{\@dotsep}{10000} 

% ******************************* Nomenclature *********************************
\RequirePackage[intoc]{nomencl}
\makenomenclature
\renewcommand{\nomgroup}[1]{%
\ifthenelse{\equal{#1}{A}}{\item[\textbf{Roman Symbols}]}{%
\ifthenelse{\equal{#1}{G}}{\item[\textbf{Greek Symbols}]}{%
\ifthenelse{\equal{#1}{Z}}{\item[\textbf{Acronyms / Abbreviations}]}{%
\ifthenelse{\equal{#1}{R}}{\item[\textbf{Superscripts}]}{%
\ifthenelse{\equal{#1}{S}}{\item[\textbf{Subscripts}]}{%
\ifthenelse{\equal{#1}{X}}{\item[\textbf{Other Symbols}]}
{}
}% matches mathematical symbols > X
}% matches Subscripts           > S
}% matches Superscripts         > R
}% matches Abbreviations        > Z
}% matches Greek Symbols        > G
}% matches Roman Symbols        > A

% To add nomenclature in the header
\renewcommand{\nompreamble}{\markboth{\nomname}{\nomname}}

% Add nomenclature to contents and print out nomenclature
\newcommand{\printnomencl}[1][]{
\ifthenelse{\equal {#1}{}}
{\printnomenclature}
{\printnomenclature[#1]}
%\addcontentsline{toc}{chapter}{\nomname}
}


% ***************************** Create the index *******************************
\ifPHD@index
    \RequirePackage{makeidx}
    \makeindex
    \newcommand{\printthesisindex}{
        \cleardoublepage
        \phantomsection
        \printindex}
\else
    \newcommand{\printthesisindex}{}
\fi


% ***************************** Chapter Mode ***********************************
% The chapter mode allows user to only print particular chapters with references
% All other options are disabled by default
% To include only specific chapters without TOC, LOF, Title and Front Matter
% To send it to supervisior for changes

\ifPHD@chapter
    \defineChaptertrue
    % Disable the table of contents, figures, tables, index and nomenclature
    \renewcommand{\maketitle}{}
    \renewcommand{\tableofcontents}{}
    \renewcommand{\listoffigures}{}
    \renewcommand{\listoftables}{}
    \renewcommand{\listofalgorithms}{}
    \renewcommand{\printnomencl}{}
    \renewcommand{\printthesisindex}{}
    \renewcommand{\publications}{}
\else
    \defineChapterfalse
\fi

% ******************************** Abstract ************************************
% The abstract environment puts a large, bold, centered "Abstract" label at
% the top of the page. Defines both abstract and separate abstract environment

% To include only the Title and the abstract pages for submission to BoGS
\ifPHD@abstract
    \defineAbstracttrue
    % Disable the table of contents, figures, tables, index and nomenclature
    \renewcommand{\tableofcontents}{}
    \renewcommand{\listoffigures}{}
    \renewcommand{\listoftables}{}
    \renewcommand{\listofalgorithms}{}
    \renewcommand{\printnomencl}{}
    \renewcommand{\printnomencl}[1][2]{}
    \renewcommand{\publications}{}
    \renewcommand{\printthesisindex}{}
    \renewcommand{\bibname}{}
    \renewcommand{\bibliography}[1]{\thispagestyle{empty}}
\else
    \defineAbstractfalse
\fi


\newenvironment{abstract} {
\ifPHD@abstract
% Separate abstract as per Student Registry guidelines
  \setsinglecolumn
  \begin{center}
    { \Large {\bfseries {\@title}} \par}
    {{\large \vspace*{1em} \@author} \par}
  \end{center}
\else
% Normal abstract in the thesis
  \cleardoublepage
  \setsinglecolumn
  \chapter*{\centering \LARGE Abstract}
\fi
\thispagestyle{PageStyleIII}
}


\fancypagestyle{plain}{% Redefining plain page style
  
  \fancyhf{} %clear all header and footer fields
  \renewcommand{\headrulewidth}{0pt}
  \fancyfoot[C]{\thepage}
}

%************************ List of publications *************************

\newenvironment{publications}{
\cleardoublepage
\setsinglecolumn
\chapter*{\centering \LARGE Publications from the \@doctype}
\addcontentsline{toc}{chapter}{Publications from the \@doctype}
% \thispagestyle{PageStyleIII}
\thispagestyle{plain}
}


% ****************************** Biography ********************************
% Brief biography of the authors
% 
\newenvironment{mybio}{
\cleardoublepage
\setsinglecolumn
\chapter*{\centering \LARGE Author Biography}
\addcontentsline{toc}{chapter}{Author Biography}
\thispagestyle{plain}
% \thispagestyle{PageStyleIII}
}



% ******************** To compute empty space in title page *******************
% Boxes below are used to space different contents on the title page
% Based on https://github.com/nitc/thesis

\newcommand{\computeTitlePageSpacing}{


% Title Box
\newsavebox{\PHD@Title}
\begin{lrbox}{\PHD@Title}
  \begin{minipage}[c]{0.98\textwidth}
    \ifthenelse{\equal{\PHD@papersize}{b5paper}}{
    \centering \Large \bfseries{\MakeUppercase{\@title}}}{}
    \ifthenelse{\equal{\PHD@papersize}{a5paper}}{
    \centering \large \bfseries{\@title}}{}
    \ifthenelse{\equal{\@subtitle}{}}{
      % subtitle is not defined
    }{
      \\
      \centering \Large {\@subtitle}
    } % subtitle is defined
  \end{minipage}
\end{lrbox}

% Submission Box
\newsavebox{\PHD@submission}
\begin{lrbox}{\PHD@submission}
  \begin{minipage}[c]{\textwidth}
    \ifthenelse{\equal{\PHD@papersize}{b5paper}}{\normalsize}{}
    \ifthenelse{\equal{\PHD@papersize}{a5paper}}{\small}{}
    \begin{center}
       A \textbf{\@doctype} \\
       \submissiontext \\
       \textbf {\@degreetitle} \\
       \textit{by}
    \end{center}
  \end{minipage}
\end{lrbox}

% Author Box
\newsavebox{\PHD@author}
\begin{lrbox}{\PHD@author}
  \begin{minipage}[c]{\textwidth}
   
    \centering \ifthenelse{\equal{\PHD@papersize}{b5paper}}{\large}{}
	       \ifthenelse{\equal{\PHD@papersize}{a5paper}}{\normalsize}{} \textbf{\textit{\@author}}  
     \ifthenelse{\equal{\@rollnum}{}} {}
     {\ifthenelse{\equal{\PHD@papersize}{b5paper}}{\normalsize}{}
      \ifthenelse{\equal{\PHD@papersize}{a5paper}}{\small}{} \\ Roll No: \@rollnum}
      \vspace{0.5em}   
  \end{minipage}
\end{lrbox}

% Supervision Box
\newsavebox{\PHD@supervise}
\begin{lrbox}{\PHD@supervise}
  \begin{minipage}[c]{\textwidth}
    \begin{center}
      \ifthenelse{\equal{\PHD@papersize}{b5paper}}{\normalsize}{}
      \ifthenelse{\equal{\PHD@papersize}{a5paper}}{\small}{} \textit{\supervisetext}
    \end{center}
  \end{minipage}
\end{lrbox}


% guide Box
\newsavebox{\PHD@guide}
\begin{lrbox}{\PHD@guide}
  \begin{minipage}[c]{\textwidth}
    \ifthenelse{\equal{\@guide}{}}{
      % guide is not defined
    }{
     \begin{center}
%         \makebox[\@guidelinewidth][c]{
          \ifthenelse{\equal{\PHD@papersize}{b5paper}}{\large}{}
          \ifthenelse{\equal{\PHD@papersize}{a5paper}}{\normalsize}{}
%          \parbox[t]{\@guidelinewidth}{ 
         \centering \@guide %}
%         }
      \end{center}
      \vspace{0.1em}
    } % guide is defined
  \end{minipage}
%   \vspace*{0.5em}
\end{lrbox}


% guide 2 Box
\newsavebox{\PHD@coguide}
\begin{lrbox}{\PHD@coguide}
  \begin{minipage}[c]{\textwidth}
    \ifthenelse{\equal{\@coguide}{}}{
      % guide is not defined
    }{
     \begin{center}
%         \makebox[\@guidelinewidth][c]{
          \ifthenelse{\equal{\PHD@papersize}{b5paper}}{\large}{}
          \ifthenelse{\equal{\PHD@papersize}{a5paper}}{\normalsize}{}
%          \parbox[t]{\@guidelinewidth}{ 
         \centering \@coguide %}
%         }
      \end{center}
      \vspace{0.1em}
    } % guide is defined
  \end{minipage}
%   \vspace*{0.5em}
\end{lrbox}

% guide 2 Box
\newsavebox{\PHD@guidemore}
\begin{lrbox}{\PHD@guidemore}
  \begin{minipage}[c]{\textwidth}
    \ifthenelse{\equal{\@guidemore}{}}{
      % guide is not defined
    }{
     \begin{center}
%         \makebox[\@guidelinewidth][c]{
          \ifthenelse{\equal{\PHD@papersize}{b5paper}}{\large}{}
          \ifthenelse{\equal{\PHD@papersize}{a5paper}}{\normalsize}{}
%          \parbox[t]{\@guidelinewidth}{ 
         \centering \@guidemore %}
%         }
      \end{center}
      \vspace{0.1em}
    } % guide is defined
  \end{minipage}
%   \vspace*{0.5em}
\end{lrbox}

% University Crest Box
\newsavebox{\PHD@crest}
\vspace*{0.5em}
\begin{lrbox}{\PHD@crest}
  {\@crest \par}
\end{lrbox}

% Department Box
\newsavebox{\PHD@dept}
\begin{lrbox}{\PHD@dept}
  \begin{minipage}[c]{\textwidth}
    \centering {\ifthenelse{\equal{\PHD@papersize}{b5paper}}{\large}{} 
                \ifthenelse{\equal{\PHD@papersize}{a5paper}}{\normalsize\bfseries}{} \scshape \@dept \par}
	       {\ifthenelse{\equal{\PHD@papersize}{b5paper}}{\large}{}
                \ifthenelse{\equal{\PHD@papersize}{a5paper}}{\normalsize}{} \scshape {\bfseries \@university \par} {\small \@univaddress} \par}
  \end{minipage}
\end{lrbox}


% College and Date Box
\newsavebox{\PHD@collegedate}
\begin{lrbox}{\PHD@collegedate}
\begin{minipage}[c]{\textwidth}
  \ifthenelse{\equal{\PHD@papersize}{b5paper}}{\large}{}
  \ifthenelse{\equal{\PHD@papersize}{a5paper}}{\normalsize}{}
  \ifthenelse{\equal{\@college}{}}{
    % college is not defined
    \begin{center}
      \@degreedate
    \end{center}
  }{
    % college is defined
    \begin{minipage}[b]{0.49\textwidth}
      \flushleft\@college
    \end{minipage}
    \begin{minipage}[b]{0.49\textwidth}
      \flushright \@degreedate
    \end{minipage}
  } % college is defined
\end{minipage}
\end{lrbox}

%  Now to compute the free vertical space
\newlength{\PHD@titlepagespacing}
\setlength{\PHD@titlepagespacing}{ \textheight %
			- \totalheightof{\usebox{\PHD@Title}}
			- \totalheightof{\usebox{\PHD@crest}}
			- \totalheightof{\usebox{\PHD@supervise}}
			- \totalheightof{\usebox{\PHD@author}}
                   	- \totalheightof{\usebox{\PHD@guide}}
                   	- \totalheightof{\usebox{\PHD@coguide}}
                   	- \totalheightof{\usebox{\PHD@guidemore}}
			- \totalheightof{\usebox{\PHD@dept}}
			- \totalheightof{\usebox{\PHD@submission}}
			- \totalheightof{\usebox{\PHD@collegedate}}
}
}


%=============================================================================
% END FILE
%=============================================================================
